//+------------------------------------------------------------------+
//|                                               FXIgorSystem.mq4   |
//|                                               Diego G. Almeida   |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"


 //extern bool       UseHourTrade   = False;
 //extern int        FromHourTrade  =   8;
 //extern int        ToHourTrade    =  18;
   extern double     TrailingStop   =  10;
   extern double     TakeProfit     =   5;
   extern double     StopLoss       =  30;
   extern double     Lots           = 1.0;
   extern double     Slippage       =   1;
   extern int        hourtoclose    =  25;


//extern double Lots         = 1.0;                       
//extern double takeProfit   = 0;                         
//extern double Slippage     = 1;
//extern int hourtoclose = 23;

double highday=0,lowday=0,h=0,l=0,media=0,mediacalc=0,Buy=0,Sell=0; //,TrailingStop=0,StopLoss=0;
int cnt,dia=0,op=0,limitepos=0;
int init() 
{return(0);}


int start()
{if(AccountFreeMargin() < 10*Lots) 
{Print("Not enough money to trade ");
return(0);}
int orders=0,hour=0;
if(Day() != dia)
{int R1=0,R5=0,R10=0,R20=0,RAvg=0;
int i=0;

   R1 =  (iHigh(NULL,PERIOD_D1,1)-iLow(NULL,PERIOD_D1,1))/Point;
   for(i=1;i<=5;i++)
      R5    =    R5  +  (iHigh(NULL,PERIOD_D1,i)-iLow(NULL,PERIOD_D1,i))/Point;
   for(i=1;i<=10;i++)
      R10   =    R10 +  (iHigh(NULL,PERIOD_D1,i)-iLow(NULL,PERIOD_D1,i))/Point;
   for(i=1;i<=20;i++)
      R20   =    R20 +  (iHigh(NULL,PERIOD_D1,i)-iLow(NULL,PERIOD_D1,i))/Point;

   R5 = R5/5;
   R10 = R10/10;
   R20 = R20/20;
   RAvg  =  (R1+R5+R10+R20)/4;    
   media=RAvg/2;
   mediacalc=MathCeil(media);
//   TrailingStop=mediacalc;
//   StopLoss=mediacalc;
   h=0;
   l=0;
   dia=Day();
   op=0;
   limitepos=0;}
   
   highday=iHigh(NULL,PERIOD_D1,0);
   lowday=iLow(NULL,PERIOD_D1,0);

if(highday > h)
   h=highday;
if(lowday < l)
   l=lowday;
   
Print("Trailing stop ",TrailingStop);
Print("Mediacalc ",mediacalc);

hour=hourtoclose - Hour();

int total=OrdersTotal();
if(total >0) 

{for(cnt=0;cnt<total;cnt++)
{if(OrderSymbol() == Symbol() && OrderType() == OP_BUY)
{op=1;}
if(OrderSymbol() == Symbol() && OrderType() == OP_SELL)
{op=2;}} 
for(cnt=0;cnt<total;cnt++)
{OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
if(OrderType()==OP_BUY && OrderSymbol()==Symbol())
{if(TrailingStop > 0) 
{if(Bid-OrderOpenPrice() > TrailingStop*Point)
{if(OrderStopLoss() < (Bid - TrailingStop*Point))
if(OrderTakeProfit() > 0)
OrderModify(OrderTicket(),OrderOpenPrice(),Bid-TrailingStop*Point,Ask + TakeProfit*Point,0,Blue);}}}   

else 

{if(OrderType()==OP_SELL && OrderSymbol()==Symbol())
{if(TrailingStop > 0) 
{if(OrderOpenPrice() - Ask > TrailingStop*Point)
{if(OrderStopLoss() == 0 || OrderStopLoss() > Ask + TrailingStop*Point)
if(OrderTakeProfit() > 0)
OrderModify(OrderTicket(),OrderOpenPrice(),Ask+TrailingStop*Point,Bid - TakeProfit*Point,0,Red);}}}}

if(OrderSymbol()==Symbol() && OrderType() == OP_BUY)
{if(Hour() >= hourtoclose && Hour() < 23)
OrderClose(OrderTicket(),OrderLots(),Bid,3,Lime);
orders=1;}
if(OrderSymbol()==Symbol() && OrderType() == OP_SELL)
{if(Hour() >= hourtoclose && Hour() < 23)
OrderClose(OrderTicket(),OrderLots(),Ask,3,Lime);
orders=1;}}}
    
else

//hour=hourtoclose - Hour();
{if(hour >= 1)
{if(orders == 0 && op == 2 && limitepos <2)
{OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,Ask-StopLoss*Point,Ask + TakeProfit*Point,"Power:Buy",16384,0,Lime);
limitepos+=1;}
if(orders == 0 && op == 1 && limitepos <2)
{OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,Bid+StopLoss*Point,Bid - TakeProfit*Point,"Power:Sell",16384,0,Red);
limitepos+=1;}}}

if(hour >=1)
{if(orders == 0 && op == 0 && limitepos <2)
{Buy=lowday+mediacalc*Point;
 Sell=highday-mediacalc*Point;
   
Comment("\n Filtro para ponto de entrada: ",mediacalc," pips \n Preo para compra: ",Buy,"\n Preo para venda: ",Sell);
   
Print("Preo para compra: ",Buy);
Print("Preo para venda: ",Sell);
if(Bid >= Buy)
{Print("Buy");
OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,Ask-StopLoss*Point,Ask + TakeProfit*Point,"Power:Buy",16384,0,Lime);      
limitepos+=1;}

if(Bid <= Sell)
{Print("Sell");
OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,Bid+StopLoss*Point,Bid - TakeProfit*Point,"Power:Sell",16384,0,Red);
limitepos+=1;}}}

return(0);}

